<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
<title>org-protocol.el &#x2013; Intercept calls from emacsclient to trigger custom actions</title>
<!-- 2013-09-25 Wed 05:37 -->
<meta  http-equiv="Content-Type" content="text/html;charset=utf-8" />
<meta  name="generator" content="Org-mode" />
<script type="text/javascript">
<!--/*--><![CDATA[/*><!--*/
function makeUrl() {
return encodeURIComponent(location.href)+
'/'+encodeURIComponent(document.title)+
'/'+encodeURIComponent(window.getSelection());
}
function storeLink() {
document.location.href='org-protocol://store-link://'+makeUrl();
}
function remember() {
document.location.href='org-protocol://remember://'+makeUrl();
}
function capture() {
document.location.href='org-protocol://capture://'+makeUrl();
}
/*]]>*///-->
</script>
<script type="text/javascript">
/*
@licstart  The following is the entire license notice for the
JavaScript code in this tag.

Copyright (C) 2012  Free Software Foundation, Inc.

The JavaScript code in this tag is free software: you can
redistribute it and/or modify it under the terms of the GNU
General Public License (GNU GPL) as published by the Free Software
Foundation, either version 3 of the License, or (at your option)
any later version.  The code is distributed WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE.  See the GNU GPL for more details.

As additional permission under GNU GPL version 3 section 7, you
may distribute non-source (e.g., minimized or compacted) forms of
that code without the copy of the GNU GPL normally required by
section 4, provided you include this license notice and a URL
through which recipients can access the Corresponding Source.


@licend  The above is the entire license notice
for the JavaScript code in this tag.
*/
<!--/*--><![CDATA[/*><!--*/
 function CodeHighlightOn(elem, id)
 {
   var target = document.getElementById(id);
   if(null != target) {
     elem.cacheClassElem = elem.className;
     elem.cacheClassTarget = target.className;
     target.className = "code-highlighted";
     elem.className   = "code-highlighted";
   }
 }
 function CodeHighlightOff(elem, id)
 {
   var target = document.getElementById(id);
   if(elem.cacheClassElem)
     elem.className = elem.cacheClassElem;
   if(elem.cacheClassTarget)
     target.className = elem.cacheClassTarget;
 }
/*]]>*///-->
</script>
<script type="text/javascript">
    function rpl(expr,a,b) {
      var i=0
      while (i!=-1) {
         i=expr.indexOf(a,i);
         if (i>=0) {
            expr=expr.substring(0,i)+b+expr.substring(i+a.length);
            i+=b.length;
         }
      }
      return expr
    }

    function show_org_source(){
       document.location.href = rpl(document.location.href,"html","org.html");
    }
</script>
<script type="text/javascript" src="http://orgmode.org/mathjax/MathJax.js"></script>
<script type="text/javascript">
<!--/*--><![CDATA[/*><!--*/
    MathJax.Hub.Config({
        // Only one of the two following lines, depending on user settings
        // First allows browser-native MathML display, second forces HTML/CSS
        //  config: ["MMLorHTML.js"], jax: ["input/TeX"],
            jax: ["input/TeX", "output/HTML-CSS"],
        extensions: ["tex2jax.js","TeX/AMSmath.js","TeX/AMSsymbols.js",
                     "TeX/noUndefined.js"],
        tex2jax: {
            inlineMath: [ ["\\(","\\)"] ],
            displayMath: [ ['$$','$$'], ["\\[","\\]"], ["\\begin{displaymath}","\\end{displaymath}"] ],
            skipTags: ["script","noscript","style","textarea","pre","code"],
            ignoreClass: "tex2jax_ignore",
            processEscapes: false,
            processEnvironments: true,
            preview: "TeX"
        },
        showProcessingMessages: true,
        displayAlign: "center",
        displayIndent: "2em",

        "HTML-CSS": {
             scale: 100,
             availableFonts: ["STIX","TeX"],
             preferredFont: "TeX",
             webFont: "TeX",
             imageFont: "TeX",
             showMathMenu: true,
        },
        MMLorHTML: {
             prefer: {
                 MSIE:    "MML",
                 Firefox: "MML",
                 Opera:   "HTML",
                 other:   "HTML"
             }
        }
    });
/*]]>*///-->
</script>
</head>
<body>
<div id="preamble" class="status">
<script type="text/javascript">

  var _gaq = _gaq || [];
  _gaq.push(['_setAccount', 'UA-7691209-1']);
  _gaq.push(['_trackPageview']);

  (function() {
    var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
    ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
    var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
  })();

  document.addEventListener('DOMContentLoaded',function() {
      document.getElementById("table-of-contents").onclick = function() {
          var elem = document.getElementById("text-table-of-contents");
          elem.style.display = elem.style.display == "block" ? "none" : "block";
      }
  });
</script>
</div>
<div id="content">
<h1 class="title">org-protocol.el &#x2013; Intercept calls from emacsclient to trigger custom actions</h1>
<div id="table-of-contents">
<h2>Table of Contents</h2>
<div id="text-table-of-contents">
<ul>
<li><a href="#sec-1">About org-protocol.el</a></li>
<li><a href="#sec-2">Installation</a></li>
<li><a href="#sec-3">Browser / system setup</a>
<ul>
<li><a href="#sec-3-1">Linux setup (Gnome)</a></li>
<li><a href="#sec-3-2">Linux setup (KDE)</a></li>
<li><a href="#sec-3-3">Windows setup</a></li>
<li><a href="#sec-3-4">Mac OS X setup</a></li>
<li><a href="#sec-3-5">Applications</a>
<ul>
<li><a href="#sec-3-5-1">Firefox</a></li>
<li><a href="#acrobat-reader-setup">Acrobat Reader</a></li>
<li><a href="#sec-3-5-3">Opera</a></li>
<li><a href="#sec-3-5-4">Safari</a></li>
</ul>
</li>
<li><a href="#sec-3-6">Verify the installation</a></li>
</ul>
</li>
<li><a href="#sec-4">Using org-protocol</a></li>
<li><a href="#sec-5">Links and bookmarks: <code>org-protocol-store-link</code></a></li>
<li><a href="#sec-6">Note taking and citations: <code>org-protocol-capture</code></a>
<ul>
<li><a href="#sec-6-1">Which capture template is used?</a>
<ul>
<li><a href="#sec-6-1-1">An example capture template</a></li>
</ul>
</li>
<li><a href="#sec-6-2">Org-protocol-remember</a>
<ul>
<li><a href="#sec-6-2-1">An example remember template</a></li>
</ul>
</li>
</ul>
</li>
<li><a href="#sec-7">Edit published content: <code>org-protocol-open-source</code></a>
<ul>
<li><a href="#sec-7-1">Handle rewritten URLs</a></li>
</ul>
</li>
<li><a href="#sec-8">Other browsers</a>
<ul>
<li><a href="#sec-8-1">Conkeror setup</a></li>
<li><a href="#uzbl">Uzbl</a></li>
</ul>
</li>
<li><a href="#sec-9">Keybindings for Firefox</a></li>
<li><a href="#sec-10">Screencast: small introduction to org-protocol.el</a></li>
</ul>
</div>
</div>
<p>
<a href="index.html">{Back to Worg's contibutions index}</a>
</p>

<p>
org-protocol intercepts calls from emacsclient to trigger custom actions without
external dependencies. Only one protocol has to be configured with your external
applications or the operating system, to trigger an arbitrary number of custom
actions. Just register your custom sub-protocol and handler with the variable
`org-protocol-protocol-alist'.
</p>
<div id="outline-container-sec-1" class="outline-2">
<h2 id="sec-1">About org-protocol.el</h2>
<div class="outline-text-2" id="text-1">
<p>
<code>org-protocol.el</code> is based on code and ideas from <a href="./org-annotation-helper.html">org-annotation-helper.el</a> and
<code>org-browser-url.el</code>.
</p>

<p>
"<code>org-protocol:/sub-protocol:/</code>" triggers actions associated with <code>sub-protocol</code>
through the custom variable <code>org-protocol-protocol-alist</code>.
</p>

<p>
It comes with four predefined handlers:
</p>
<dl class="org-dl">
<dt> <code>org-protocol-store-link</code> </dt><dd>      triggered through the sub-protocol "<code>store-link</code>". Stores an Org-link and
pushes the URL to the <code>kill-ring</code>.
</dd>
<dt> <code>org-protocol-capture</code> </dt><dd>      Fill a <code>CAPTURE</code> buffer with information gathered somewhere else. This
handler is triggered through the "<code>capture</code>" sub-protocol and uses the
function <code>org-capture</code>.
</dd>
<dt> <code>org-protocol-remember</code> </dt><dd>      Fills a remember buffer with information gathered somewhere else. This
handler is triggered through the "<code>remember</code>" sub-protocol and still
available for backward compatibility. This handler uses <code>org-remember</code>. Use
the current <code>org-protocol-capture</code>.
</dd>

<dt> <code>org-protocol-open-source</code> </dt><dd>      "<code>open-source</code>". Maps URLs to local filenames. Use this to open sources of
already published contents in emacs for editing.
</dd>
</dl>

<p>
<code>org-protocol</code> helps creating custom handlers <a href="../org-tutorials/org-protocol-custom-handler.html">(tutorial)</a> and so called
<code>org-protocol-projects</code>.
</p>

<p>
<div class="org-info-box"><img src="/worg/images/icons/info.png" alt="NOTE" /><p>
@&lt;b&gt;As of Org mode release 7.01 <code>org-protocol-remember</code> is now by <code>org-protocol-capture</code>.@&lt;/b&gt;
If not stated otherwise, you may simply replace each occurrence of
<i>capture</i> with <i>remember</i> throughout this document, if you still want to use
remember templates. Use <code>M-x org-version</code> to find out about the version you're
using.
</p><br style="clear:left;height:1px;" /></div><br />
</p>
</div>
</div>

<div id="outline-container-sec-2" class="outline-2">
<h2 id="sec-2">Installation</h2>
<div class="outline-text-2" id="text-2">
<ul class="org-ul">
<li>To load org-protocol.el add the following to your <code>.emacs</code>:

<pre class="example">
(server-start)
(add-to-list 'load-path "~/path/to/org/protocol/")
(require 'org-protocol)
</pre>
</li>
</ul>
</div>
</div>
<div id="outline-container-sec-3" class="outline-2">
<h2 id="sec-3">Browser / system setup</h2>
<div class="outline-text-2" id="text-3">
<ul class="org-ul">
<li><a href="#sec-3-1">Linux setup (Gnome)</a>
</li>
<li><a href="#sec-3-2">Linux setup (KDE)</a>
</li>
<li><a href="#sec-3-3">Windows setup</a>
</li>
<li><a href="#sec-3-4">Mac OS X setup</a>
</li>
</ul>
</div>

<div id="outline-container-sec-3-1" class="outline-3">
<h3 id="sec-3-1">Linux setup (Gnome)</h3>
<div class="outline-text-3" id="text-3-1">
<p>
For this to work, you'll need the Gnome-Libraries to be installed.
</p>

<pre class="example">
gconftool-2 -s /desktop/gnome/url-handlers/org-protocol/command '/usr/local/bin/emacsclient %s' --type String
gconftool-2 -s /desktop/gnome/url-handlers/org-protocol/enabled --type Boolean true
</pre>
</div>
</div>
<div id="outline-container-sec-3-2" class="outline-3">
<h3 id="sec-3-2">Linux setup (KDE)</h3>
<div class="outline-text-3" id="text-3-2">
<p>
Add a file <code>org.protocol</code> to <code>~/.kde/share/kde4/services/</code>:
</p>

<pre class="example">
# -*- conf -*-
[Protocol]
protocol=org-protocol
exec=/usr/bin/emacsclient '%u'
input=none
output=none
helper=true
listing=
reading=false
writing=false
makedir=false
deleting=false
Icon=emacs
Description=A protocol for org-mode
</pre>
</div>
</div>

<div id="outline-container-sec-3-3" class="outline-3">
<h3 id="sec-3-3">Windows setup</h3>
<div class="outline-text-3" id="text-3-3">
<p>
Windows users may register the "<code>org-protocol</code>" once for all by adjusting the
following to their facts, save it as *.reg file and double-click it. This
worked for me on Windows-XP Professional and the emasc23 from ourcomments.org
(<a href="http://ourcomments.org/cgi-bin/emacsw32-dl-latest.pl">http://ourcomments.org/cgi-bin/emacsw32-dl-latest.pl</a>). I'm no Windows user
though and enhancements are more than welcome on the org-mode mailinglist. The
original file is from <a href="http://kb.mozillazine.org/Register_protocol">http://kb.mozillazine.org/Register_protocol</a>.
</p>

<pre class="example">
REGEDIT4

[HKEY_CLASSES_ROOT\org-protocol]
@="URL:Org Protocol"
"URL Protocol"=""
[HKEY_CLASSES_ROOT\org-protocol\shell]
[HKEY_CLASSES_ROOT\org-protocol\shell\open]
[HKEY_CLASSES_ROOT\org-protocol\shell\open\command]
@="\"C:\\Programme\\Emacs\\emacs\\bin\\emacsclientw.exe\" \"%1\""
</pre>
</div>
</div>
<div id="outline-container-sec-3-4" class="outline-3">
<h3 id="sec-3-4">Mac OS X setup</h3>
<div class="outline-text-3" id="text-3-4">
<p>
Follow the directions for installing EmacsClient.app from <a href="https://github.com/neil-smithline-elisp/EmacsClient.app">https://github.com/neil-smithline-elisp/EmacsClient.app</a>. This should configure the org-protocol for all Mac OS X browsers.
</p>

<p>
After installing EmacsClient.app you should then <a href="#sec-3-6">Verify the installation</a>. Once verified, you can begin <a href="#sec-4">Using org-protocol</a>.
</p>
</div>
</div>
<div id="outline-container-sec-3-5" class="outline-3">
<h3 id="sec-3-5">Applications</h3>
<div class="outline-text-3" id="text-3-5">
</div>
<div id="outline-container-sec-3-5-1" class="outline-4">
<h4 id="sec-3-5-1">Firefox</h4>
<div class="outline-text-4" id="text-3-5-1">
<p>
If you are using Firefox on Mac OS X, see <a href="#sec-3-4">Mac OS X setup</a>. 
</p>


<p>
Please refer to <a href="http://kb.mozillazine.org/Register_protocol">http://kb.mozillazine.org/Register_protocol</a> and use
"org-protocol" as protocol.
</p>
</div>
</div>

<div id="outline-container-acrobat-reader-setup" class="outline-4">
<h4 id="acrobat-reader-setup"><a id="sec-3-5-2" name="sec-3-5-2"></a>Acrobat Reader</h4>
<div class="outline-text-4" id="text-acrobat-reader-setup">

<p>
Adapted from <a href="http://article.gmane.org/gmane.emacs.orgmode/6810">http://article.gmane.org/gmane.emacs.orgmode/6810</a>
</p>

<p>
You place a javascript file for each menu entry in
<code>~/.adobe/Acrobat/&lt;VERSION&gt;/JavaScripts</code> on unix-like systems or
<code>c:/Program Files/Adobe/Acrobat &lt;VERSION&gt;/Reader/Javascripts/</code> on
Windows, or wherever your Adobe Reader Installation might look for
javascript.
</p>

<p>
The examples given here will place new menu entries in the "Tools"
menu, after restarting Adobe Reader.
</p>
</div>
<ul class="org-ul"><li>org-store-link.js<br  /><div class="outline-text-5" id="text-3-5-2-1">
<pre class="example">
// from http://article.gmane.org/gmane.emacs.orgmode/6810
app.addMenuItem({cName:"org-store-link", cParent:"Tools",
   cExec:"app.launchURL('org-protocol://store-link://' + encodeURIComponent(this.URL) + '/' + encodeURIComponent(this.info.Title));"});
</pre>
</div>
</li>

<li>org-capture.js<br  /><div class="outline-text-5" id="text-3-5-2-2">
<pre class="example">
// from http://article.gmane.org/gmane.emacs.orgmode/6810
app.addMenuItem({cName:"org-capture", cParent:"Tools",
   cExec:"app.launchURL('org-protocol://capture://' + encodeURIComponent(this.URL) + '/' + encodeURIComponent(this.info.Title) + '/');"});
</pre>

<p>
And this one, if you still use remember templates:
</p>
</div>
</li>

<li>org-remember.js<br  /><div class="outline-text-5" id="text-3-5-2-3">
<pre class="example">
// from http://article.gmane.org/gmane.emacs.orgmode/6810
app.addMenuItem({cName:"org-remember", cParent:"Tools",
   cExec:"app.launchURL('org-protocol://remember://' + encodeURIComponent(this.URL) + '/' + encodeURIComponent(this.info.Title) + '/');"});
</pre>
</div>
</li></ul>
</div>

<div id="outline-container-sec-3-5-3" class="outline-4">
<h4 id="sec-3-5-3">Opera</h4>
<div class="outline-text-4" id="text-3-5-3">
<p>
If you are using Opera on Mac OS X, see <a href="#sec-3-4">Mac OS X setup</a>. 
</p>

<p>
Opera setup is described here:
<a href="http://www.opera.com/support/kb/view/535/">http://www.opera.com/support/kb/view/535/</a>.
</p>

<p>
To set up opera for use with org-protocol, follow these steps:
</p>

<ol class="org-ol">
<li>Choose "<i>Tools</i>" -&gt; "<i>Prefences</i>" from the menu.
</li>
<li>Select the tab "<i>Advanced</i>".
</li>
<li>Choose "<i>Programs</i>" from the list on the left.
</li>
<li>Now click the button "<i>Add</i>" on the very right.
</li>
<li>In the new dialog window, enter "<code>org-protocol</code>" as "<i>Protocol</i>", choose the
radio button "<i>Open with other application</i>" and enter the path to
emacsclient.
</li>
</ol>
</div>
</div>
<div id="outline-container-sec-3-5-4" class="outline-4">
<h4 id="sec-3-5-4">Safari</h4>
<div class="outline-text-4" id="text-3-5-4">
<p>
Safari is only supported on Mac systems, not iOS systems.
</p>

<p>
See <a href="#sec-3-4">Mac OS X setup</a> for directions.
</p>
</div>
</div>
</div>

<div id="outline-container-sec-3-6" class="outline-3">
<h3 id="sec-3-6">Verify the installation</h3>
<div class="outline-text-3" id="text-3-6">
<p>
After your protocol is registered with your browser/OS, these links here
should work. Click on them and see if emacs reacts:
</p>

<ul>
 <li><a href="javascript:storeLink();">Org store-link</a></li>
 <li><a href="javascript:capture();">Org capture (select some text if you like)</a></li>
 <li><a href="javascript:remember();">Org remember (select some text please)</a></li>
</ul>
</div>
</div>
</div>

<div id="outline-container-sec-4" class="outline-2">
<h2 id="sec-4">Using org-protocol</h2>
<div class="outline-text-2" id="text-4">
<p>
To actually use org-protocol add a bookmark to Firefox or Opera.
</p>

<p>
Here is the URL to use as "<i>Location</i>" for browser bookmarks. Just remove the
line breaks and replace "<code>sub-protocol</code>" with the real sub-protocol to use:
</p>

<pre class="example">
javascript:location.href='org-protocol://sub-protocol://'+
      encodeURIComponent(location.href)+'/'+
      encodeURIComponent(document.title)+'/'+
      encodeURIComponent(window.getSelection())
</pre>

<p>
This URL may be used for all three standard handlers in <code>org-protocol.el</code>. Some
of the values will be ignored (e.g. <code>store-link:/</code> will use the URL and title
only).
</p>
</div>
</div>

<div id="outline-container-sec-5" class="outline-2">
<h2 id="sec-5">Links and bookmarks: <code>org-protocol-store-link</code></h2>
<div class="outline-text-2" id="text-5">
<p>
<code>org-store-link</code> stores an Org-link insertable through <code>M-x org-insert-link</code> and
pushes the URL found onto the <code>kill-ring</code> for yanking (<code>C-y</code>). The sub-protocol
used is "<code>store-link</code>":
</p>

<pre class="example">
emacsclient org-protocol:/store-link:/URL/TITLE
</pre>

<p>
will store this Org-link:
</p>

<pre class="example">
[[URL][TITLE]]
</pre>

<p>
In addition, <code>URL</code> will be pushed on the <code>kill-ring</code> for yanking ('<code>C-y</code>'). You will
have to encode <code>URL</code> and/or <code>TITLE</code> if they contain slashes, and probably quote
those for the shell.
</p>

<p>
To use this feature, add a bookmark with an arbitrary name (e.g.
"<i>Org: store-link</i>") and enter this as "<code>Location</code>":
</p>

<pre class="example">
javascript:location.href='org-protocol://store-link://'+encodeURIComponent(location.href)
</pre>
</div>
</div>

<div id="outline-container-sec-6" class="outline-2">
<h2 id="sec-6">Note taking and citations: <code>org-protocol-capture</code></h2>
<div class="outline-text-2" id="text-6">
<p>
This one is triggered through the sub-protocol "<code>capture</code>" and consumes up to
three data fields:
</p>

<pre class="example">
emacsclient org-protocol:/capture:/URL/TITLE/BODY
</pre>

<p>
will pop up an <i><b>Capture</b></i> buffer and fill the template with the data
submitted.
</p>

<p>
To use this feature, add a bookmark with an arbitrary name (e.g.
"<i>Org: capture</i>") and enter this as "<code>Location</code>":
</p>

<pre class="example">
javascript:location.href='org-protocol://capture://'+
      encodeURIComponent(location.href)+'/'+
      encodeURIComponent(document.title)+'/'+
      encodeURIComponent(window.getSelection())
</pre>

<p>
The result depends on the template used. See <i>An example capture template</i>
further down.
</p>

<p>
Note, that this one, as opposed to the other two standard handlers, does not
mix with more parameters to emacsclient. All parameters but the
</p>
<p>
#'<code>org-protocol://org-capture://...</code>' one will be discarded.
</p>
</div>
<div id="outline-container-sec-6-1" class="outline-3">
<h3 id="sec-6-1"><a id="org:f56bcb9a-20e7-4b37-99f1-839a8821cc4b" name="org:f56bcb9a-20e7-4b37-99f1-839a8821cc4b"></a>Which capture template is used?</h3>
<div class="outline-text-3" id="text-6-1">

<p>
You don't need to setup a capture template to use <code>org-protocol-capture</code>,
since Org-mode provides a default template for those cases.  Newer versions
provide an interactive interface for choosing a template.  You may provide a
template to be used by customizing the variable
<code>org-capture-default-template</code> <sup><a id="fnr.1" name="fnr.1" class="footref" href="#fn.1">1</a></sup>.
</p>

<p>
The problem with this solution would be, that only one template can be used
with the fuction. Luckily, <code>org-protocol-capture</code> understands a slightly
extended syntax to choose between several templates: If the first field of
the data submitted is exactly one character in length, this character will
be used to select the template.
</p>

<p>
Here we choose to use the "<code>x</code>" template:
</p>

<pre class="example">
emacsclient org-protocol:/capture:/x/URL/TITLE/BODY
</pre>

<p>
And, again, as bookmark location:
</p>
<pre class="example">
javascript:location.href='org-protocol://capture://x/'+
      encodeURIComponent(location.href)+'/'+
      encodeURIComponent(document.title)+'/'+
      encodeURIComponent(window.getSelection())
</pre>
</div>
<div id="outline-container-sec-6-1-1" class="outline-4">
<h4 id="sec-6-1-1">An example capture template</h4>
<div class="outline-text-4" id="text-6-1-1">
<div class="org-src-container">

<pre class="src src-emacs-lisp">(setq org-capture-templates
      (quote
       ((<span style="color: #daa520; font-style: italic;">"w"</span>
         <span style="color: #daa520; font-style: italic;">"Default template"</span>
         entry
         (file+headline <span style="color: #daa520; font-style: italic;">"~/org/capture.org"</span> <span style="color: #daa520; font-style: italic;">"Notes"</span>)
         <span style="color: #daa520; font-style: italic;">"* %^{Title}\n\n  Source: %u, %c\n\n  %i"</span>
         <span style="font-weight: bold;">:empty-lines</span> 1)
        <span style="font-weight: bold; font-style: italic;">;; </span><span style="font-weight: bold; font-style: italic;">... more templates here ...</span>
        )))
</pre>
</div>

<dl class="org-dl">
<dt> "<code>w</code>" </dt><dd>makes this one the default template used for
"<code>org-protocol://capture://</code>" URLs.
</dd>
<dt> <code>entry</code> </dt><dd>makes it a regular entry with a headline.
</dd>
<dt> <code>file+headline</code> </dt><dd>files the note in file "<code>~/org/capture.org</code>" as child of
the headline "<code>Notes</code>"
</dd>
<dt> '<code>%c</code>' </dt><dd>will be replaced by an Org-link pointing to the location of the
page you have been visiting when clicking on the link. The page
title will be the link's description.
</dd>
<dt> '<code>%i</code>' </dt><dd>will be replaced by the selected text in your browser window if
any.
</dd>
</dl>

<p>
In addition, you may use the following placeholders in your template:
</p>

<table border="2" cellspacing="0" cellpadding="6" rules="groups" frame="hsides">


<colgroup>
<col  class="left" />

<col  class="left" />
</colgroup>
<thead>
<tr>
<th scope="col" class="left">Placeholders</th>
<th scope="col" class="left">Replacement</th>
</tr>
</thead>
<tbody>
<tr>
<td class="left"><code>%:link</code></td>
<td class="left">URL of the web-page</td>
</tr>

<tr>
<td class="left"><code>%:description</code></td>
<td class="left">The title of the web-page</td>
</tr>

<tr>
<td class="left"><code>%:initial</code></td>
<td class="left">Selected text.</td>
</tr>
</tbody>
</table>

<p>
You may read more about templates and their special escape characters in the
<a href="http://orgmode.org/manual/Capture-templates.html#Capture-templates">Org-mode manual</a>.
</p>
</div>
</div>
</div>

<div id="outline-container-sec-6-2" class="outline-3">
<h3 id="sec-6-2">Org-protocol-remember</h3>
<div class="outline-text-3" id="text-6-2">
<p>
The <code>org-protocol-remember</code> handler is now obsolete.  However, the handler is
still available for backward compatibility.  To use this handler, closely
follow the setup for the current <code>org-protocol-capture</code> handler, and simply
replace each occurrence of <i>capture</i> with <i>remember</i>.
</p>

<p>
As remember templates look slightly different than capture templates, we
provide an example here.
</p>
</div>
<div id="outline-container-sec-6-2-1" class="outline-4">
<h4 id="sec-6-2-1">An example remember template</h4>
<div class="outline-text-4" id="text-6-2-1">
<div class="org-src-container">

<pre class="src src-emacs-lisp">(setq org-remember-templates
      '((?w <span style="color: #daa520; font-style: italic;">"* %^{Title}\n\n  Source: %u, %c\n\n  %i"</span> nil <span style="color: #daa520; font-style: italic;">"Notes"</span>)))
</pre>
</div>

<dl class="org-dl">
<dt> '<code>?w</code>' </dt><dd>makes this one the default template used for
"<code>org-protocol://remember://</code>" URLs.
</dd>
<dt> '<code>%c</code>' </dt><dd>will be replaced by an Org-link pointing to the location of the
page you have been visiting when clicking on the link. The page
title will be the link's description.
</dd>
<dt> '<code>%i</code>' </dt><dd>will be replaced by the selected text in your browser window if
any.
</dd>
</dl>

<p>
In addition, you may use the following placeholders in your template:
</p>

<table border="2" cellspacing="0" cellpadding="6" rules="groups" frame="hsides">


<colgroup>
<col  class="left" />

<col  class="left" />
</colgroup>
<thead>
<tr>
<th scope="col" class="left">Placeholders</th>
<th scope="col" class="left">Replacement</th>
</tr>
</thead>
<tbody>
<tr>
<td class="left"><code>%:link</code></td>
<td class="left">URL of the web-page</td>
</tr>

<tr>
<td class="left"><code>%:description</code></td>
<td class="left">The title of the web-page</td>
</tr>

<tr>
<td class="left"><code>%:initial</code></td>
<td class="left">Selected text.</td>
</tr>
</tbody>
</table>

<p>
You may read more about templates and their special escape characters in the
<a href="http://orgmode.org/manual/Capture-templates.html#Capture-templates">Org-mode manual</a>.
</p>
</div>
</div>
</div>
</div>

<div id="outline-container-sec-7" class="outline-2">
<h2 id="sec-7">Edit published content: <code>org-protocol-open-source</code></h2>
<div class="outline-text-2" id="text-7">
<p>
This one was designed to help with opening sources for editing when browsing
in the first place. <code>org-protocol-open-source</code> uses the custom variable
<code>org-protocol-project-alist</code> to map URLs to (local) filenames.
</p>

<p>
Let's take <a href="http://orgmode.org/worg/">http://orgmode.org/worg/</a> as our example.
</p>

<p>
Our intention is to click a bookmark (or link) to open the source of the
published file we are reading in our favourite editor. The bookmark-URL above
could be used again. But since <code>org-protocol-open-source</code> regards the first
field only, this here will do:
</p>

<pre class="example">
javascript:location.href='org-protocol://open-source://'+encodeURIComponent(location.href)
</pre>

<p>
To open files publihed on Worg locally, <code>org-protocol-project-alist</code> should look
like this (you may skip the second project):
</p>

<div class="org-src-container">

<pre class="src src-emacs-lisp">(setq org-protocol-project-alist
      '((<span style="color: #daa520; font-style: italic;">"Worg"</span>
         <span style="font-weight: bold;">:base-url</span> <span style="color: #daa520; font-style: italic;">"http://orgmode.org/worg/"</span>
         <span style="font-weight: bold;">:working-directory</span> <span style="color: #daa520; font-style: italic;">"/home/user/worg/"</span>
         <span style="font-weight: bold;">:online-suffix</span> <span style="color: #daa520; font-style: italic;">".html"</span>
         <span style="font-weight: bold;">:working-suffix</span> <span style="color: #daa520; font-style: italic;">".org"</span>)
        (<span style="color: #daa520; font-style: italic;">"My local Org-notes"</span>
         <span style="font-weight: bold;">:base-url</span> <span style="color: #daa520; font-style: italic;">"http://localhost/org/"</span>
         <span style="font-weight: bold;">:working-directory</span> <span style="color: #daa520; font-style: italic;">"/home/user/org/"</span>
         <span style="font-weight: bold;">:online-suffix</span> <span style="color: #daa520; font-style: italic;">".php"</span>
         <span style="font-weight: bold;">:working-suffix</span> <span style="color: #daa520; font-style: italic;">".org"</span>)))
</pre>
</div>

<p>
If you're now browsing <a href="http://orgmode.org/worg/org-contrib/org-protocol.html">http://orgmode.org/worg/org-contrib/org-protocol.html</a>
and find a typo or have an idea how to enhance the documentation, simply click
the bookmark and start editing.
</p>

<p>
There are two functions to help you fill <code>org-protocol-project-alist</code> with
valid contents. One possibility is <code>org-protocol-create</code> that guides you through
the process. If you're editing an Org-mode file that is part of a publishing
project in <code>org-publish-project-alist</code>, try
</p>

<pre class="example">
M-x org-protocol-create-for-org RET
</pre>
</div>
<div id="outline-container-sec-7-1" class="outline-3">
<h3 id="sec-7-1">Handle rewritten URLs</h3>
<div class="outline-text-3" id="text-7-1">
<p>
In some cases, replacing <code>:base-url</code> with <code>:working-directory</code> and
<code>:online-suffix</code> with <code>:working-suffix</code> will not yield the desired results.
</p>

<p>
Suppose you maintain an online store located at <code>http://example.com/</code>. The
local sources reside in <code>/home/user/example/</code>. While most of the URLs map
directly to local file names by stripping URL parameters from the end and
replacing the <code>:base-url</code> with <code>:working-diretory</code> and <code>:online-suffix</code> with
<code>:working-suffix</code>, this might not work for rewritten URLs. It's common
practice to serve all products in such a store through one file and rewrite
URLs that do not match an existing file on the server.
</p>

<p>
That way, a request to <code>http://example.com/print/posters-A4.html</code> might be
rewritten on the server to something like
<code>http://example.com/shop/products.php/posters-A4.html.php</code>, where
<code>/posters-A4-digital.html.php</code> is the so called path info. Note that the
browser will not notice the rewrite.
</p>

<p>
If you now click your <code>org-protocol://open-source://</code> bookmark, the handler
will probably not find a file named
<code>/home/user/example/print/posters-A4.html.php</code> and fail.
</p>

<p>
Or, even more simple, assume you're browsing <code>http://example.com/</code>. A file
named <code>/home/user/example/.php</code> is not likely to exist.
</p>

<p>
Since Org-mode commit <code>69b46e10aab3b2374ecbc1a963ba56e77102a9a4</code> from 15th
Nov. 2009, such an entry in <code>org-protocol-project-alist</code> may hold an
additional property <code>:rewrites</code>. This property is a list of cons cells, each
of which maps a regular expression to a path relative to the
<code>:working-directory</code>.
</p>

<p>
Now map the URL to the path <code>/home/user/example/products.php</code> by adding the
<code>:rewrites</code> property like this:
</p>

<div class="org-src-container">

<pre class="src src-emacs-lisp">(setq org-protocol-project-alist
      '((<span style="color: #daa520; font-style: italic;">"example.com"</span>
         <span style="font-weight: bold;">:base-url</span> <span style="color: #daa520; font-style: italic;">"http://example.com/"</span>
         <span style="font-weight: bold;">:working-directory</span> <span style="color: #daa520; font-style: italic;">"/home/user/example/"</span>
         <span style="font-weight: bold;">:online-suffix</span> <span style="color: #daa520; font-style: italic;">".php"</span>
         <span style="font-weight: bold;">:working-suffix</span> <span style="color: #daa520; font-style: italic;">".php"</span>
         <span style="font-weight: bold;">:rewrites</span> ((<span style="color: #daa520; font-style: italic;">"example.com/print/"</span> . <span style="color: #daa520; font-style: italic;">"products.php"</span>)
                    (<span style="color: #daa520; font-style: italic;">"example.com/$"</span> . <span style="color: #daa520; font-style: italic;">"index.php"</span>))
         )))
</pre>
</div>

<p>
Guess what the second <code>:rewrites</code> element does. Since <code>example.com/$</code> is used as
a regular expression, it maps <code>http://example.com/</code>, <code>https://example.com</code>,
<code>http://www.example.com/</code> and similar to <code>/home/user/example/index.php</code>.
</p>

<p>
The <code>:rewrites</code> are searched as a last resort if and only if no existing file
name is matched.
</p>
</div>
</div>
</div>
<div id="outline-container-sec-8" class="outline-2">
<h2 id="sec-8">Other browsers</h2>
<div class="outline-text-2" id="text-8">
<p>
#<a id="conkeror-setup" name="conkeror-setup"></a>
</p>
</div>
<div id="outline-container-sec-8-1" class="outline-3">
<h3 id="sec-8-1">Conkeror setup</h3>
<div class="outline-text-3" id="text-8-1">
<p>
Setting up org-protocol in <a href="http://conkeror.org/">Conkeror</a> (an emacs inspired Mozilla web
browser) requires a slightly different method. You may simply add the
following snippets of code to your .conkerorrc file.<sup><a id="fnr.2" name="fnr.2" class="footref" href="#fn.2">2</a></sup>
</p>

<p>
For org-store-link, add the following to .conkerorrc:
</p>

<pre class="example">
function org_store_link (url, title, window) {
    var cmd_str = 'emacsclient \"org-protocol://store-link://'+url+'/'+title+'\"';
    if (window != null) {
        window.minibuffer.message('Issuing ' + cmd_str);
    }
    shell_command_blind(cmd_str);
}

interactive("org-store-link", "Stores [[url][title]] as org link and copies url to emacs kill ring",
            function (I) {
                org_store_link(encodeURIComponent(I.buffer.display_uri_string), encodeURIComponent(I.buffer.document.title), I.window);
            });
</pre>

<p>
For org-capture (or org-remember &#x2014; just exchange <i>capture</i> with <i>remember</i>), use
the following:
</p>

<pre class="example">
function org_capture (url, title, selection, window) {
    var cmd_str = 'emacsclient \"org-protocol://capture://'+url+'/'+title+'/'+selection+'\"';
    if (window != null) {
        window.minibuffer.message('Issuing ' + cmd_str);
    }
    shell_command_blind(cmd_str);
}

interactive("org-capture", "Clip url, title, and selection to capture via org-protocol",
            function (I) {
                org_capture(encodeURIComponent(I.buffer.display_uri_string), encodeURIComponent(I.buffer.document.title), encodeURIComponent(I.buffer.top_frame.getSelection()), I.window);
            });
</pre>

<p>
Now, you should be able to invoke the commands from within conkeror
with <code>M-x org-store-link</code> and <code>M-x org-capture</code> (or remember).
</p>

<p>
Or, if you'd like your familiar emacs keybindings, you can add the
following to your .conkerorrc:
</p>

<pre class="example">
define_key(content_buffer_normal_keymap, "C-c r", "org-capture");
define_key(content_buffer_normal_keymap, "C-c l", "org-store-link");
</pre>
</div>
</div>
<div id="outline-container-uzbl" class="outline-3">
<h3 id="uzbl"><a id="sec-8-2" name="sec-8-2"></a>Uzbl</h3>
<div class="outline-text-3" id="text-uzbl">

<p>
Uzbl is a minimalistic webkit browser for Unix/Linux.
</p>

<ul class="org-ul">
<li><a href="http://www.uzbl.org/">http://www.uzbl.org/</a>
</li>
</ul>

<p>
You can pass encoded url data from uzbl to org-protocol by adding the
following lines to <code>.config/uzbl/config</code>.
</p>

<pre class="example">
# Org-protocol

@cbind 	\\r = sh 'emacsclient "org-protocol://capture://\@&lt;encodeURIComponent(window.location.href)&gt;\@/\@&lt;encodeURIComponent(document.title)&gt;\@/\@&lt;document.getSelection()&gt;\@"'
@cbind 	\\l = sh 'emacsclient "org-protocol://capture://\@&lt;encodeURIComponent(window.location.href)&gt;\@/\@&lt;encodeURIComponent(document.title)&gt;\@"'
</pre>

<p>
These bind org-protocol-capture and org-store-line to "\r" and "\l" respectively.
</p>
</div>
</div>
</div>

<div id="outline-container-sec-9" class="outline-2">
<h2 id="sec-9">Keybindings for Firefox</h2>
<div class="outline-text-2" id="text-9">
<p>
You can add key bindings for the <code>org-protocol</code> commands using the keyconfig
Firefox extension.
</p>

<p>
First, install keyconfig from <a href="http://mozilla.dorando.at/keyconfig.xpi">http://mozilla.dorando.at/keyconfig.xpi</a>.
</p>

<p>
Open the keyconfig dialog by going to Tools and then Keyconfig.
</p>

<p>
Click the 'Add a new Key' button. Enter "Org store link" as the name.
Enter the following in the box with <i>* CODE *</i> in it:
</p>

<pre class="example">
var orgProtoString = 'org-protocol://store-link://'+
  encodeURIComponent(gBrowser.currentURI.spec) + '/' +
  encodeURIComponent(gBrowser.contentWindow.document.title) + '/' +
  encodeURIComponent(gBrowser.contentWindow.getSelection());

gBrowser.loadURI(orgProtoString);
</pre>

<p>
Click OK. You will then need to bind a key by clicking in the box next to the
'Apply' button and pressing whatever key combination you want. Click 'Apply' to
store the keybinding.
</p>

<p>
Repeat the steps, but call the next key "Org capture" and use the code below:
</p>

<pre class="example">
var orgProtoString = 'org-protocol://capture://'+
  encodeURIComponent(gBrowser.currentURI.spec) + '/' +
  encodeURIComponent(gBrowser.contentWindow.document.title) + '/' +
  encodeURIComponent(content.window.getSelection());

gBrowser.loadURI(orgProtoString);
</pre>

<p>
Click Close, then OK, and then restart Firefox. You should then be able to
access the org-protocol functions with your chosen keys.
</p>
</div>
</div>

<div id="outline-container-sec-10" class="outline-2">
<h2 id="sec-10">Screencast: small introduction to org-protocol.el</h2>
<div class="outline-text-2" id="text-10">
<object width="640" height="464"><param name="allowfullscreen"
value="true" /><param name="allowscriptaccess" value="always" /><param
name="movie"
value="http://vimeo.com/moogaloop.swf?clip_id=5662410&amp;server=vimeo.com&amp;show_title=1&amp;show_byline=1&amp;show_portrait=1&amp;color=FF7700&amp;fullscreen=1"
/><embed
src="http://vimeo.com/moogaloop.swf?clip_id=5662410&amp;server=vimeo.com&amp;show_title=1&amp;show_byline=1&amp;show_portrait=1&amp;color=FF7700&amp;fullscreen=1"
type="application/x-shockwave-flash" allowfullscreen="true"
allowscriptaccess="always" width="640" height="464"></embed></object>

<p>
This screencast shows off some nice things you can do with Firefox,
Emacs, Org-mode and org-protocol.el.
</p>

<p>
It first shows how to create two bookmarklets, <code>org-capture</code> and
<code>org-store-link</code>. These bookmarklets enable your Firefox to talk to
emacsclient via a new protocol (<code>org-protocol://</code>); emacsclient then
parses the request and tells Emacs to capture or store stuff at the
relevant places in your Org files.
</p>

<p>
At the end of the screencast, we create two ubiquity commands from these
bookmarklets.  Now in Firefox <code>ALT-SPC org-capture RET</code> creates a note
in my Org files.
</p>
</div>
</div>
<div id="footnotes">
<h2 class="footnotes">Footnotes: </h2>
<div id="text-footnotes">

<div class="footdef"><sup><a id="fn.1" name="fn.1" class="footnum" href="#fnr.1">1</a></sup> <p class="footpara">
Before commit <code>fc49c1ec96b2c789f573ae1ba936b930a8494402</code>, 3rd Sept. 2010,
if a template with the key string "<code>w</code>" was defined, this one was chosen by
default.  This was done to make bookmarks used for <a href="./org-annotation-helper.el">org-annotation-helper</a> work
without changing the template.
</p></div>

<div class="footdef"><sup><a id="fn.2" name="fn.2" class="footnum" href="#fnr.2">2</a></sup> <p class="footpara">
Adapted from Tassilo Horn's blog, "Calling
org-remember from inside conkeror," November 14, 2008.
<a href="http://tsdh.wordpress.com/2008/11/14/calling-org-remember-from-inside-conkeror/">http://tsdh.wordpress.com/2008/11/14/calling-org-remember-from-inside-conkeror/</a>
</p></div>


</div>
</div></div>
<div id="postamble" class="status">
<div id="show_source"><input type="button" value="Show Org source" onClick='show_org_source()'></div><div id="license"><p>Documentation from the http://orgmode.org/worg/ website (either in its HTML format or in its Org format) is licensed under the <a href="http://www.gnu.org/copyleft/fdl.html">GNU Free Documentation License version 1.3</a> or later.  The code examples and css stylesheets are licensed under the <a href="http://www.gnu.org/licenses/gpl.html">GNU General Public License v3</a> or later.</p></div>
</div>
</body>
</html>
